<%@ LANGUAGE = VBScript %>
<%
' '
' shopfactory_email.asp is the Active Server Pages version of '
' shopfactory5_emailNew.cgi and works exactly the same way, except '
' it will not to PGP encryption. '
' '
' Requirements of shopfactory_order.asp: '
'    IIS 4.0 '
'    (should work on IIS 3.0+ but has not been tested) '
' '
' Requirements of shopfactory_email.asp: '
'    IIS 4.0 with SMTP service '
'    (should work with Exchange Server instead of SMTP service '
'    but has not been tested.  Our script uses the CDONTS object '
'    which is included with the SMTP service and apparently with '
'    Exchange Server) '
' '
' '
' '

' Valid referers '
Const Num_Referers = 12
Dim Referers(12)	' Unfortunately this has to be 11 not Num_Referers which would be neater '
Referers(0) = "shopfactory_order.asp"	' standard '
Referers(1) = "ordernav.html"			' standard '
Referers(2) = "authorized.html"			' various payment systems '
Referers(3) = "VueltaOk.html"			' banesto '
Referers(4) = "vuelta.exe"				' banesto '
Referers(5) = "shopwizard_order.asp"	' obsolete '
Referers(6) = "method.html"				' standard with custom payment fields '
Referers(7) = "order2.html"				' obsolete '
Referers(8) = "order3.html"				' obsolete '
Referers(9) = "order4.html"				' obsolete '
Referers(10) = "customerdtl.html"		' obsolete '
Referers(11) = "deliverydtl.html"		' obsolete '
Referers(12) = "fields.html"			' standard with custom payment fields '

' External_Prefix is the prefix to append to lockssl-on.gif and thankyou_url if necessary.
' If you want to use "/files/lockssl-on.gif" and "/files/thankyou.html" then External_Prefix
' must be set to '/files/'
External_Prefix = ""

' The date as a string '
The_Date = ""

' Carriage Return/Linefeed Pair '
CR = Chr(13)
LF = Chr(10)
CRLF = CR & LF

' Default language translations '
ln_badreferer		= "Bad Referrer - Access Denied"
ln_badreferer_desc	= "The URL of the form that is trying to use this CGI application is not in the list of valid referrers."
ln_error_missing	= "Missing Fields"
ln_error			= "Error"
ln_orderfrom		= "Order from"
ln_submitted		= "Submitted by"
ln_email			= "email"
ln_date				= "date"
ln_confirm			= "Order confirmation from"

Sub Translate_Defaults
	If Request.Form("ln_badreferer") <> "" then
		ln_badreferer = Request.Form("ln_badreferer")
	End If
	If Request.Form("ln_badreferer_desc") <> "" then
		ln_badreferer = Request.Form("ln_badreferer_desc")
	End If
	If Request.Form("ln_error_missing") <> "" then
		ln_badreferer = Request.Form("ln_error_missing")
	End If
	If Request.Form("ln_error") <> "" then
		ln_badreferer = Request.Form("ln_error")
	End If
	If Request.Form("ln_orderfrom") <> "" then
		ln_badreferer = Request.Form("ln_orderfrom")
	End If
	If Request.Form("ln_submitted") <> "" then
		ln_badreferer = Request.Form("ln_submitted")
	End If
	If Request.Form("ln_email") <> "" then
		ln_badreferer = Request.Form("ln_email")
	End If
	If Request.Form("ln_date") <> "" then
		ln_badreferer = Request.Form("ln_date")
	End If
	If Request.Form("ln_confirm") <> "" then
		ln_badreferer = Request.Form("ln_confirm")
	End If
End Sub

Function Check_Referer()
	Check_Referer = True
	Referer = Request.ServerVariables("HTTP_REFERER")
	If Len(Referer) = 0 Then
		Exit Function
	End If

	For i = 0 To Num_Referers
		If InStr(Referer, Referers(i)) > 0 Then
			Exit Function
		End If
	Next

	Response.Write "<html"
	If Request.Form("html_lang") <> "" Then
		Response.Write " lang=""" & Request.Form("html_lang") & """"
	End If
	If Request.Form("html_dir") <> "" Then
		Response.Write " dir=""" & Request.Form("html_dir") & """"
	End If
	Response.Write ">" & CRLF
	Response.Write "<head>" & CRLF
	If Request.Form("http_charset") <> "" Then
		Response.Write "<meta http-equiv=""Content-Type"" content=""text/html; charset=" & Request.Form("http_charset") & """>" & CRLF
	End If
	Response.Write "</head>" & CRLF
	Response.Write "<body"
	Response.Write Body_Attributes
	Response.Write ">" & CRLF
	Response.Write "<center><h1>" & ln_badreferer & "</h1></center>" & CRLF
	Response.Write ln_badreferer_desc & CRLF
	Response.Write "</body></html>"

	Check_Referer = False
End Function

Function Get_Date()
	dt = Now
	If Request.Form("date_format") <> "" Then
		df = Request.Form("date_format")
		date_str = ""
		index = 1
		While index <= Len(df)
			m = Mid(df,index)
			If Left(UCase(m),4) = "YYYY" Then
			    date_str = date_str & Year(dt)
			    index = index + 4
			ElseIf Left(UCase(m),2) = "MM" Then
				m = Month(dt)
				If m < 10 Then
					date_str = date_str & "0"
				End If
				date_str = date_str & Month(dt)
				index = index + 2
			ElseIf Left(UCase(m),2) = "DD" Then
				d = Day(dt)
				If d < 10 Then
					date_str = date_str & "0"
				End If
				date_str = date_str & Day(dt)
				index = index + 2
			Else
				date_str = date_str & Mid(df, index, 1)
				index = index + 1
			End If
		Wend
		Get_Date = date_str
	Else
		Get_Date =	WeekdayName(Weekday(dt)) & ", " & _
					MonthName(Month(dt)) & " " & _
					Day(dt) & ", " & _
					Year(dt) & _
					" at " & _
					Hour(dt) & ":" & _
					Minute(dt) & ":" & _
					Second(dt)
	End If
End Function

Function Body_Attributes()
	s = ""

	If Request.Form("bgcolor") <> "" Then
		s = s & " bgcolor=""" & Request.Form("bgcolor") & """"
	End If
	If Request.Form("link_color") <> "" Then
		s = s & " link=""" & Request.Form("link_color") & """"
	End If
	If Request.Form("vlink_color") <> "" Then
		s = s & " vlink=""" & Request.Form("vlink_color") & """"
	End If
	If Request.Form("alink_color") <> "" Then
		s = s & " alink=""" & Request.Form("alink_color") & """"
	End If
	If Request.Form("text_color") <> "" Then
		s = s & " text=""" & Request.Form("text_color") & """"
	End If

	Body_Attributes = s
End Function

Function Unescape_Email(e)
	Unescape_Email = Replace(e, "\n", CRLF)
End Function

Function Encode_Header(strText, strCharset, strEncoding, nMaxLen)
	r = ""
	e = ""
	t = ""
	If LCase(strEncoding) = "quoted-printable" Then
		e = Encode_Head_QP(strText, nMaxLen)
		t = "Q"
	ElseIf LCase(strEncoding) = "base64" Then
		e = Encode_Base64(strText, LF, nMaxLen)
		t = "B"
	End If
	If e <> "" Then
		el = Split(e, LF)

		For i = 0 To UBound(el)
			If Len(el(i)) > 0 Then
				r = r & "=?" & strCharset & "?" & t & "?" & el(i) & "?="
				If i <> UBound(el) Then
					r = r & CRLF & " "
				End If
			End If
		Next
	Else
		r = strText
	End If
	Encode_Header = r
End Function

Function Encode_Base64(strRes, strEol, nMaxLen)
	Encode_Base64 = strRes & LF
End Function

Function Encode_QP(strRes)
	Encode_QP = strRes
End Function

Function Encode_Head_QP(strRes, nMaxLen)
	Encode_Head_QP = strRes & LF
End Function

Function sendmail(strTo, strFrom, strSubject, strBody)
	encodedbody = ""
	encodedsubject = ""

	Set objNewMail = Server.CreateObject("CDONTS.NewMail")

	objNewMail.Send strTo, strFrom, strSubject, strBody
	Set objNewMail = Nothing
	Exit Function

	objNewMail.SetLocaleIDs 932
	objNewMail.MailFormat = 0	' MIME
	objNewMail.BodyFormat = 1	' Text
	objNewMail.To = strTo
	objNewMail.From = strFrom

	If Request.Form("http_charset") <> "" And Request.Form("mail_encoding") <> "" Then
		if LCase(Request.Form("mail_encoding")) = "quoted-printable" or LCase(Request.Form("mail_encoding")) = "base64" Then
			'objNewMail.Value("MIME-Version") = "1.0"
			'objNewMail.Value("Content-Type") = "text/plain; charset=" & Request.Form("http_charset")
			'objNewMail.Value("Content-transfer-encoding") = Request.Form("mail_encoding")
			objNewMail.Value("x-3d3-should-be-encoded") = "yes"
			If LCase(Request.Form("mail_encoding")) = "quoted-printable" Then
				encodedbody = CRLF & Encode_QP(strBody)
			Else
				encodedbody = CRLF & Encode_Base64(strBody, LF, 76)
			End If
		Else
			encodedbody = CRLF & strBody
		End If

		'encodedsubject = Encode_Header(strSubject, Request.Form("http_charset"), Request.Form("mail_encoding"), 40)
		encodedsubject = strSubject
	Else
		encodedbody = CRLF & strBody
		encodedsubject = strSubject
	End If

	objNewMail.Value("Subject") = encodedsubject
	'objNewMail.Body = encodedbody
	objNewMail.Body = strBody

	objNewMail.Send

	Set objNewMail = Nothing
End Function

Function Send_Email()
	If Len(Request.Form("recipient")) = 0 Then
		Response.Write "<html"
		If Request.Form("html_lang") <> "" Then
			Response.Write " lang=""" & Request.Form("html_lang") & """"
		End If
		If Request.Form("html_dir") <> "" Then
			Response.Write " dir=""" & Request.Form("html_dir") & """"
		End If
		Response.Write ">" & CRLF
		Response.Write "<head>" & CRLF
		If Request.Form("http_charset") <> "" Then
			Response.Write "<meta http-equiv=""Content-Type"" content=""text/html; charset=" & Request.Form("http_charset") & """>" & CRLF
		End If
		Response.Write "</head>" & CRLF
		Response.Write "<body"
		Response.Write Body_Attributes
		Response.Write ">" & CRLF
		Response.Write "<center><img src=""" & External_Prefix & "lockssl-on.gif""></center><br>" & CRLF
		Response.Write "<br><br><br><br><center>" & CRLF
		Response.Write "<font size=""+2"">" & Request.Form("ln_email_required") & "</font><br><br>" & CRLF
		Response.Write "</center>"
		Response.Write "</body></html>"
		Send_Email = False
		Exit Function
	End If

	Email_Header =	"----------------------------------------" & CRLF & _
					ln_orderfrom & ": " & Request.Form("shopname") & CRLF & _
					ln_submitted & ": " & Request.Form("customer_name") & CRLF & _
					ln_email & ": " & Request.Form("customer_email") & CRLF & _
					ln_date & ": " & The_Date & CRLF & _
					"----------------------------------------" & CRLF & CRLF

	Order_Email = Unescape_Email(Request.Form("order_email"))

	Email_Payment =	CRLF & "----- " & Request.Form("ln_payment_method") & " -----" & CRLF
	Email_Payment = Email_Payment & _
					Request.Form("ln_payment_method") & ": " & Request.Form("payment_method") & CRLF
	For Each f In Request.Form
		If Left(f, 6) = "field_" Then
			t = Right(f, Len(f)-6)
			Email_Payment = Email_Payment & t & ": " & Request.Form(f) & CRLF
		End If
	Next

	Email_Footer = 	CRLF & "----- " & Request.Form("ln_total") & " -----" & CRLF & _
					Request.Form("ln_total_weight") & ": " & Request.Form("total_weight") & CRLF & _
					Request.Form("ln_purchase_price") & ": " & Request.Form("currency_symbol") & " " & Request.Form("total_ex_tax") & CRLF & _
					Request.Form("ln_total_tax") & ": " & Request.Form("currency_symbol") & " " & Request.Form("tax_value") & CRLF & _
					Request.Form("ln_total_shipping") & ": " & Request.Form("currency_symbol") & " " & Request.Form("shipping_value") & CRLF & _
					Request.Form("ln_total_inc") & ": " & Request.Form("currency_symbol") & " " & Request.Form("total_inc_tax") & CRLF & _
					CRLF & "Browser: " & Request.ServerVariables("HTTP_USER_AGENT") & CRLF & _
					"Remote Host: " & Request.ServerVariables("REMOTE_HOST") & CRLF & _
					"Remote Address: " & Request.ServerVariables("REMOTE_ADDR") & CRLF

	Merchant_Email = Email_Header & Order_Email & Email_Payment & Email_Footer
	Customer_Email = Email_Header & Order_Email & Email_Footer

	' Email merchant
	sendmail _
		Request.Form("recipient"), _
		Request.Form("customer_email"), _
		ln_orderfrom & " " & Request.Form("shopname"), _
		Merchant_Email

	' Email customer if applicable
	If Request.Form("dont_email_customer") <> "true" Then
		If InStr(Request.Form("customer_email"), "@") <> 0 Then
			sendmail _
				Request.Form("customer_email"), _
				Request.Form("recipient"), _
				ln_confirm & " " & Request.Form("shopname"), _
				Customer_Email
		End If
	End If

	Send_Email = True
End Function

Sub Print_Html
	Thankyou_Prefix = ""
	If Request.Form("thankyou_url") = "thankyou.html" Then
		Thankyou_Prefix = External_Prefix
	End If
	Response.Write "<html"
	If Request.Form("html_lang") <> "" Then
		Response.Write " lang=""" & Request.Form("html_lang") & """"
	End If
	If Request.Form("html_dir") <> "" Then
		Response.Write " dir=""" & Request.Form("html_dir") & """"
	End If
	Response.Write ">" & CRLF
	Response.Write "<head>" & CRLF
	If Request.Form("http_charset") <> "" Then
		Response.Write "<meta http-equiv=""Content-Type"" content=""text/html; charset=" & Request.Form("http_charset") & """>" & CRLF
	End If
	Response.Write "<meta http-equiv=""refresh"" content=""3;url=" & Thankyou_Prefix & Request.Form("thankyou_url") & """>" & CRLF
	Response.Write "</head>" & CRLF
	Response.Write "<body"
	Response.Write Body_Attributes
	Response.Write ">" & CRLF
	Response.Write "<center><img src=""" & External_Prefix & "lockssl-on.gif""></center><br>" & CRLF
	Response.Write "<br><br><br><br><center>" & CRLF
	Response.Write "<font size=""+2"">" & Request.Form("ln_secure_final") & "</font><br><br>" & CRLF
	Response.Write "<a href=""" & Thankyou_Prefix & Request.Form("thankyou_url") & """>"
	Response.Write "<font size=""-1"">" & Request.Form("ln_next") & "</font></a>" & CRLF
	Response.Write "</center>"
	Response.Write "</body></html>"
End Sub

Sub Redirect
	Thankyou_Prefix = ""
	If Request.Form("thankyou_url") = "thankyou.html" Then
		Thankyou_Prefix = External_Prefix
	End If
	Response.Redirect Thankyou_Prefix & Request.Form("thankyou_url")
End Sub

' ----- execution starts here -----

Translate_Defaults

If Check_Referer() = True Then
	The_Date = Get_Date()
	If Send_Email = True Then
		If Request.Form("redirect_only") <> "true" Then
			Print_Html
		Else
			Redirect
		End If
	End If
End If

%>